#
# Run with: rpm -bb gcc-rpm.pkg
#
Summary: GNU C, C++, Ada Compilers for 68HC11, 68HC12 and 68HCS12 microcontrollers
Name: gcc-68hc1x
Version: 3.3.6
Release: 3.1
Copyright: GPL
Group: Development/68HC1x
Source: gcc-3.3.6.tar.bz2
Patch: gcc-3.3.6-m68hc1x-20060122.diffs
URL: http://www.gnu-m68hc11.org
Distribution: GNU/Linux
Vendor: FSF
Packager: stcarrez@nerim.fr
Buildroot: /usr/src/RPM/BUILD/releases/3.1/gcc-inst
Prefix: /usr
%description
This package contains the cross C, C++ and Ada compilers for Motorola 68HC11, 
68HC12 and 68HCS12 microcontrollers.

%prep

%setup -T -c
cd ..
rmdir $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION
tar --use-compress=bzip2 -xf $RPM_SOURCE_DIR/gcc-3.3.6.tar.bz2
mv gcc-3.3.6 $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION
cd $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION
mkdir $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION

%patch -p1

# Create a tar.bz2 that contains the patched sources
cd ..
tar -cjf $RPM_SOURCE_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION.tar.bz2 $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION

# Configure the package
cd $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION
export PATH=/usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/bin:$PATH
sh ./configure --target=m6811-elf --program-prefix=m6811-elf- \
	--enable-languages=c,c++,ada --prefix=/usr --host=i686-linux

# Hack to put the m6811-elf-as in the gcc builtin-path
# (see gcc --print-search-dirs)
mkdir gcc/m6811-elf
cd gcc/m6811-elf
ln -s /usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/m6811-elf/bin 3.3.6
%build
# Use gcc 2.95
# export PATH=/usr/local/bin:$PATH
export PATH=/usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/bin:$PATH
make
# CFLAGS="-Os"

#
# Format the documentation
#
cd gcc
make gcc.dvi
make cpp.dvi
cd doc
/usr/local/bin/texi2html -menu -split_chapter -nosec_nav \
	  -top_file=cpp_doc.html -I . -I ./include ./cpp.texi
/usr/local/bin/texi2html -menu -split_chapter -nosec_nav \
	  -top_file=gcc_doc.html --I . -I ./include ./gcc.texi
cd ../..

#
%install
make prefix=$RPM_BUILD_ROOT/usr install
rm -f $RPM_BUILD_ROOT/usr/bin/m6811-elf-chill
rm -f $RPM_BUILD_ROOT/usr/bin/m6811-elf-gccbug
strip $RPM_BUILD_ROOT/usr/bin/m6811-elf-*
strip $RPM_BUILD_ROOT/usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/cc1
strip $RPM_BUILD_ROOT/usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/cc1plus
strip $RPM_BUILD_ROOT/usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/collect2
# mv $RPM_BUILD_ROOT/usr/bin/cpp $RPM_BUILD_ROOT/usr/bin/m6811-elf-cpp
# mv $RPM_BUILD_ROOT/usr/bin/gcov $RPM_BUILD_ROOT/usr/bin/m6811-elf-gcov
mkdir -p $RPM_BUILD_ROOT/usr/m6811-elf/bin

#
# Install the documentation
#
mkdir -p $RPM_BUILD_ROOT/usr/m6811-elf/doc
cp -p gcc/doc/cpp_*.html $RPM_BUILD_ROOT/usr/m6811-elf/doc
cp -p gcc/doc/gcc_*.html $RPM_BUILD_ROOT/usr/m6811-elf/doc

#
# Format the HTML man pages
#
echo "Building the HTML man pages..."

# On Mandrake 8.1, the groff is completely broken.
# Must use a local version of groff that works!
export PATH=/usr/local/bin:$PATH
for i in $RPM_BUILD_ROOT/usr/man/man1/*; do
  case $i in
    *.1)
      iname=$i
      name=`basename $iname .1 | sed -e 's,m6811-elf-,,'`
      cat $i | /usr/bin/man2html > $RPM_BUILD_ROOT/usr/m6811-elf/doc/$name.html
      ;;

    *.bz2)
      iname=`basename $i .bz2`
      name=`basename $iname .1 | sed -e 's,m6811-elf-,,'`
      bzip2 -c -d $i | /usr/bin/man2html > $RPM_BUILD_ROOT/usr/m6811-elf/doc/$name.html
      ;;

  esac
done

#
# Get the binutils so that we can use the gcc from
# its local installation directory to build other packages (Newlib).
#
cd $RPM_BUILD_ROOT
# Remove links to the m6811-elf binutils (using plain path to avoid problems)
rm -f usr/m6811-elf/bin/ar
rm -f usr/m6811-elf/bin/as
rm -f usr/m6811-elf/bin/ld
rm -f usr/m6811-elf/bin/nm
rm -f usr/m6811-elf/bin/ranlib
cd usr/m6811-elf/bin
# Copy the files (don't symlink because rpm does some strange
# symbolic link relativisation which breaks them)
cp -p /usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/m6811-elf/bin/ar .
cp -p /usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/m6811-elf/bin/as .
cp -p /usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/m6811-elf/bin/ld .
cp -p /usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/m6811-elf/bin/nm .
cp -p /usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/m6811-elf/bin/ranlib .
# Make sure we can remove them
chmod a+w ar as ld nm ranlib

%files
#%doc README
%attr(555,root,root) %dir /usr
%attr(555,root,root) %dir /usr/lib
%attr(555,root,root) %dir /usr/lib/gcc-lib
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/include
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/include/*.h
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/include/README
%attr(555,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/cc1
%attr(555,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/cc1plus
%attr(555,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/collect2
%attr(555,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/gnat1
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/specs
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/mlong-calls
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/fshort-double
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/fshort-double
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mlong-calls
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/mlong-calls
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/fshort-double
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/fshort-double
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mlong-calls
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/mlong-calls/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/mlong-calls/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/fshort-double/mlong-calls/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/fshort-double/mlong-calls/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/fshort-double/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/fshort-double/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mshort/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/fshort-double/mlong-calls/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/fshort-double/mlong-calls/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/fshort-double/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/fshort-double/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mlong-calls/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/mlong-calls/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/m68hc12/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/crt1.o
#%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/mlong-calls/libgcc.a
#%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/mlong-calls/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/libgcc.a
#%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/fshort-double/mlong-calls/libgcc.a
#%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/fshort-double/mlong-calls/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/fshort-double/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/fshort-double/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mshort/crt1.o
#%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/fshort-double/mlong-calls/libgcc.a
#%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/fshort-double/mlong-calls/crt1.o
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/fshort-double/libgcc.a
%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/fshort-double/crt1.o
#%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mlong-calls/libgcc.a
#%attr(444,root,root) /usr/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122/mlong-calls/crt1.o
%attr(555,root,root) %dir /usr/bin
%attr(555,root,root) /usr/bin/m6811-elf-g++
%attr(555,root,root) /usr/bin/m6811-elf-c++
%attr(555,root,root) /usr/bin/m6811-elf-cpp
%attr(555,root,root) /usr/bin/m6811-elf-gcc
%attr(555,root,root) /usr/bin/m6811-elf-gcc-*
%attr(555,root,root) /usr/bin/m6811-elf-gcov
%attr(555,root,root) %dir /usr/m6811-elf
%attr(555,root,root) %dir /usr/m6811-elf/bin
%attr(555,root,root) %dir /usr/man
%attr(555,root,root) %dir /usr/man/man1
%attr(444,root,root) /usr/man/man1/m6811-elf-gcc.1*
%attr(444,root,root) /usr/m6811-elf/doc/gcc.html
%attr(444,root,root) /usr/m6811-elf/doc/cpp_*.html
%attr(444,root,root) /usr/m6811-elf/doc/gcc_*.html

#
# Package installation.
#
%post
# Workarround for rpm Bug 75057 (fixed in rpm 4.2)
if test "T$RPM_INSTALL_PREFIX" = "T"; then
  RPM_INSTALL_PREFIX="/usr"
fi
# Create hard links to nm, strip, ar, ranlib, as, ld.
ln $RPM_INSTALL_PREFIX/bin/m6811-elf-gcc $RPM_INSTALL_PREFIX/m6811-elf/bin/gcc
ln $RPM_INSTALL_PREFIX/bin/m6811-elf-c++ $RPM_INSTALL_PREFIX/m6811-elf/bin/c++
ln $RPM_INSTALL_PREFIX/bin/m6811-elf-cpp $RPM_INSTALL_PREFIX/m6811-elf/bin/cpp

# The 68HC11 libraries compiled with -mlong-calls are identical to compiling
# without that option.  Use links.
LIBDIR="$RPM_INSTALL_PREFIX/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122"
ln $LIBDIR/libgcc.a $LIBDIR/mlong-calls/libgcc.a
ln $LIBDIR/crt1.o   $LIBDIR/mlong-calls/crt1.o
ln $LIBDIR/mshort/crt1.o $LIBDIR/mshort/mlong-calls/crt1.o
ln $LIBDIR/mshort/libgcc.a $LIBDIR/mshort/mlong-calls/libgcc.a
ln $LIBDIR/mshort/fshort-double/crt1.o $LIBDIR/mshort/fshort-double/mlong-calls/crt1.o
ln $LIBDIR/mshort/fshort-double/libgcc.a $LIBDIR/mshort/fshort-double/mlong-calls/libgcc.a
ln $LIBDIR/fshort-double/crt1.o $LIBDIR/fshort-double/mlong-calls/crt1.o
ln $LIBDIR/fshort-double/libgcc.a $LIBDIR/fshort-double/mlong-calls/libgcc.a

%preun
# Workarround for rpm Bug 75057 (fixed in rpm 4.2)
if test "T$RPM_INSTALL_PREFIX" = "T"; then
  RPM_INSTALL_PREFIX="/usr"
fi
# Remove all the hard links we created.
rm -f $RPM_INSTALL_PREFIX/m6811-elf/bin/c++
rm -f $RPM_INSTALL_PREFIX/m6811-elf/bin/gcc
rm -f $RPM_INSTALL_PREFIX/m6811-elf/bin/cpp

# The 68HC11 libraries compiled with -mlong-calls are identical to compiling
# without that option.  Remove the links.
LIBDIR="$RPM_INSTALL_PREFIX/lib/gcc-lib/m6811-elf/3.3.6-m68hc1x-20060122"
rm -f $LIBDIR/mlong-calls/libgcc.a
rm -f $LIBDIR/mlong-calls/crt1.o
rm -f $LIBDIR/mshort/mlong-calls/libgcc.a
rm -f $LIBDIR/mshort/mlong-calls/crt1.o
rm -f $LIBDIR/mshort/fshort-double/mlong-calls/libgcc.a
rm -f $LIBDIR/mshort/fshort-double/mlong-calls/crt1.o
rm -f $LIBDIR/fshort-double/mlong-calls/libgcc.a
rm -f $LIBDIR/fshort-double/mlong-calls/crt1.o

%clean
echo "Cleaning up"
#rm -rf /usr/src/RPM/BUILD/releases/3.1/gcc-inst
