#
# Run with: rpm -bb gdb-win-rpm.spec
#
# WINDOWS Binaries Generation
#
#
Summary: GNU GDB for 68HC11 and 68HC12 microcontrollers (Win32)
Name: gdb-68hc1x-win32
Version: 6.4
Release: 3.1
Copyright: GPL
Group: Development/68HC1x
Source: gdb-6.4.tar.bz2
Patch: gdb-6.4-m68hc1x-20060122.diffs
URL: http://www.gnu-m68hc11.org
Distribution: Windows 95
Vendor: FSF
Packager: stcarrez@nerim.fr
Buildroot: /usr/src/RPM/BUILD/releases/3.1/gdb-inst-win32
Prefix: /usr
%description
This package contains the cross symbolic debugger for
Motorola 68HC11 and 68HC12 microcontrollers. It also contains
a 68HC11 and a 68HC12 simulator with the Eeprom, Nvram, SCI, 
SPI and timer devices.

%prep

%setup -T -c
cd ..
rmdir $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION
tar --use-compress=bzip2 -xf $RPM_SOURCE_DIR/gdb-6.4.tar.bz2
mv gdb-6.4 $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION
cd $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION

%patch -p1
export PATH=/tools/mingw32/cross-tools-3.3/bin:/bin:/usr/bin:$PATH

mkdir build
cd build
sh ../configure --target=m6811-elf --program-prefix=m6811-elf- \
    --host=i586-mingw32msvc --build=i686-pc-linux-gnu \
    --prefix=/m6811 --disable-tui
%build
cd build
export PATH=/tools/mingw32/cross-tools-3.3/bin:/bin:/usr/bin:$PATH
make CFLAGS="-Os"
cd gdb

cd doc
make html
make gdb.pdf
cd ../..

%install
export PATH=/tools/mingw32/cross-tools-3.3/bin:$PATH
cd build
make prefix=$RPM_BUILD_ROOT/usr MAKEINFOFLAGS= install
/tools/mingw32/cross-tools-3.3/bin/i586-mingw32msvc-strip $RPM_BUILD_ROOT/usr/bin/*.exe
mkdir -p $RPM_BUILD_ROOT/usr/m6811-elf/bin

#
# Install the documentation
#
mkdir -p $RPM_BUILD_ROOT/usr/m6811-elf/doc
cp -p gdb/doc/gdb_*.html $RPM_BUILD_ROOT/usr/m6811-elf/doc
cp -p gdb/doc/gdb.pdf $RPM_BUILD_ROOT/usr/m6811-elf/doc

#
# Format the HTML man pages
#
echo "Building the HTML man pages..."
for i in $RPM_BUILD_ROOT/usr/man/man1/*; do
  case $i in
    *.1)
      iname=$i
      name=`basename $iname .1 | sed -e 's,m6811-elf-,,'`
      cat $i | /usr/bin/man2html > $RPM_BUILD_ROOT/usr/m6811-elf/doc/$name.html
      ;;

    *.bz2)
      iname=`basename $i .bz2`
      name=`basename $iname .1 | sed -e 's,m6811-elf-,,'`
      bzip2 -c -d $i | /usr/bin/man2html > $RPM_BUILD_ROOT/usr/m6811-elf/doc/$name.html
      ;;

  esac
done

#
# Dosify the text files
#
cd $RPM_BUILD_ROOT/usr
echo "Dosifying..."
apply-cmd-on-tree "*.1" unix2dos.pl
apply-cmd-on-tree "*.html" unix2dos.pl
cd $RPM_BUILD_ROOT

%files
#%doc README
%attr(555,root,root) %dir /usr/bin
%attr(555,root,root) %dir /usr/man
%attr(555,root,root) %dir /usr/man/man1
%attr(555,root,root) %dir /usr/m6811-elf
%attr(555,root,root) %dir /usr/m6811-elf/bin
%attr(555,root,root) /usr/bin/m6811-elf-gdb.exe
%attr(555,root,root) /usr/bin/m6811-elf-run.exe
%attr(444,root,root) /usr/man/man1/m6811-elf-gdb.1*
%attr(555,root,root) %dir /usr/m6811-elf/doc
%attr(444,root,root) /usr/m6811-elf/doc/gdb.html
%attr(444,root,root) /usr/m6811-elf/doc/gdb.pdf
%attr(444,root,root) /usr/m6811-elf/doc/gdb_*.html

#
# Package installation.
#
%post
# Create hard links to gdb, run.
ln $RPM_INSTALL_PREFIX/bin/m6811-elf-gdb $RPM_INSTALL_PREFIX/m6811-elf/bin/gdb
ln $RPM_INSTALL_PREFIX/bin/m6811-elf-run $RPM_INSTALL_PREFIX/m6811-elf/bin/run

%preun
# Remove all the hard links we created.
rm -f $RPM_INSTALL_PREFIX/m6811-elf/bin/gdb
rm -f $RPM_INSTALL_PREFIX/m6811-elf/bin/run

%clean
echo "Cleaning up"
#rm -rf /usr/src/RPM/BUILD/releases/3.1/gdb-inst
