#
# Run with: rpm -bb newlib-rpm.pkg
#
Summary: Newlib for 68HC11 and 68HC12 microcontrollers
Name: newlib-68hc1x
Version: 1.12.0
Release: 3.1
Copyright: GPL
Group: Development/68HC1x
Source: newlib-1.12.0.tar.bz2
Patch: newlib-1.12.0-m68hc1x-20040801.diffs
URL: http://www.gnu-m68hc11.org
Distribution: GNU/Linux
Vendor: FSF
Packager: stcarrez@nerim.fr
Buildroot: /usr/src/RPM/BUILD/releases/3.1/newlib-inst
Prefix: /usr
%description
This package contains a set of development libraries for 
Motorola 68HC11 and 68HC12 microcontrollers. 
The following libraries are provided:
  libc     - Standard C library
  libm     - Math library
  libbcc   - Board support library

These libraries are provided in several binary versions.
They are selected by gcc according to the compilation options:

 Kind         Mode     Gcc option         Mode     Gcc option
+-----------+---------------------------+----------------------------+
|Processor  | 68hc11   -m68hc11         | 68hc12   -m68hc12          |
|Integer    | 16-bits  -mshort          | 32-bits  -mnoshort         |
|Float      | 32-bits  -fshort-double   | 64-bits  -fno-short-double |
|Far calls  |                           | call/rtc -mlong-calls      |
+-----------+---------------------------+----------------------------+

Up to 16 combinations are possible (but the -mlong-calls is 
ignored for 68HC11).
%prep

%setup -T -c
cd ..
rmdir $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION
tar -xzf $RPM_SOURCE_DIR/newlib-1.12.0.tar.gz
mv newlib-1.12.0 $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION
cd $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION

%patch -p1
# Create a tar.bz2 that contains the patched sources
cd ..
tar -cjf $RPM_SOURCE_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION.tar.bz2 $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION

# Configure the package
cd $RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION
export PATH=/usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/bin:/usr/src/RPM/BUILD/releases/3.1/gcc-inst/usr/bin:/bin:/usr/bin:$PATH
dir=`pwd`
mkdir m6811
cd m6811
sh $dir/configure --target=m6811-elf --program-prefix=m6811-elf- \
   --disable-newlib-io-float --disable-newlib-multithread

%build
export PATH=/usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/bin:/usr/src/RPM/BUILD/releases/3.1/gcc-inst/usr/bin:/bin:/usr/bin:$PATH
cd m6811
make CFLAGS="-Os"

%install
export PATH=/usr/src/RPM/BUILD/releases/3.1/binutils-inst/usr/bin:/usr/src/RPM/BUILD/releases/3.1/gcc-inst/usr/bin:/bin:/usr/bin:$PATH
cd m6811
make -e prefix=$RPM_BUILD_ROOT/usr INSTALL=install install

%files
#%doc README
%attr(555,root,root) %dir /usr
%attr(555,root,root) %dir /usr/m6811-elf
%attr(555,root,root) %dir /usr/m6811-elf/lib
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/mshort
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/mshort/fshort-double
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/fshort-double
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/mshort
%attr(555,root,root) %dir /usr/m6811-elf/lib/mshort/fshort-double
%attr(555,root,root) %dir /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/mshort/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/fshort-double
%attr(555,root,root) %dir /usr/m6811-elf/lib/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/include
%attr(555,root,root) %dir /usr/m6811-elf/include/machine
%attr(555,root,root) %dir /usr/m6811-elf/include/sys
%attr(444,root,root) /usr/m6811-elf/lib/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mlong-calls/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mlong-calls/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mlong-calls/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mlong-calls/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls/libm.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls/sim-valid.ld
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls/crt0.o
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/libbcc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/mlong-calls/libm.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/mlong-calls/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/mlong-calls/sim-valid.ld
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/mlong-calls/crt0.o
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/mshort/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/mshort/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/mlong-calls/libm.a
#%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/mlong-calls/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/mlong-calls/sim-valid.ld
#%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/mlong-calls/crt0.o
#%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/libbcc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mlong-calls/libm.a
#%attr(444,root,root) /usr/m6811-elf/lib/mlong-calls/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mlong-calls/sim-valid.ld
#%attr(444,root,root) /usr/m6811-elf/lib/mlong-calls/crt0.o
#%attr(444,root,root) /usr/m6811-elf/lib/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/libbcc.a
%attr(444,root,root) /usr/m6811-elf/include/machine/*.h
%attr(444,root,root) /usr/m6811-elf/include/*.h
%attr(444,root,root) /usr/m6811-elf/include/sys/*.h

#
# Package installation.
#
%post
# Workarround for rpm Bug 75057 (fixed in rpm 4.2)
if test "T$RPM_INSTALL_PREFIX" = "T"; then
  RPM_INSTALL_PREFIX="/usr"
fi
# The 68HC11 libraries compiled with -mlong-calls are identical to compiling
# without that option.  Use links.
LIBDIR="$RPM_INSTALL_PREFIX/m6811-elf/lib"
ln $LIBDIR/libm.a $LIBDIR/mlong-calls/libm.a
ln $LIBDIR/libc.a $LIBDIR/mlong-calls/libc.a
ln $LIBDIR/sim-valid.ld $LIBDIR/mlong-calls/sim-valid.ld
ln $LIBDIR/crt0.o $LIBDIR/mlong-calls/crt0.o
ln $LIBDIR/libbcc.a $LIBDIR/mlong-calls/libbcc.a

ln $LIBDIR/mshort/libm.a $LIBDIR/mshort/mlong-calls/libm.a
ln $LIBDIR/mshort/libc.a $LIBDIR/mshort/mlong-calls/libc.a
ln $LIBDIR/mshort/sim-valid.ld $LIBDIR/mshort/mlong-calls/sim-valid.ld
ln $LIBDIR/mshort/crt0.o $LIBDIR/mshort/mlong-calls/crt0.o
ln $LIBDIR/mshort/libbcc.a $LIBDIR/mshort/mlong-calls/libbcc.a

ln $LIBDIR/mshort/fshort-double/libm.a $LIBDIR/mshort/fshort-double/mlong-calls/libm.a
ln $LIBDIR/mshort/fshort-double/libc.a $LIBDIR/mshort/fshort-double/mlong-calls/libc.a
ln $LIBDIR/mshort/fshort-double/sim-valid.ld $LIBDIR/mshort/fshort-double/mlong-calls/sim-valid.ld
ln $LIBDIR/mshort/fshort-double/crt0.o $LIBDIR/mshort/fshort-double/mlong-calls/crt0.o
ln $LIBDIR/mshort/fshort-double/libbcc.a $LIBDIR/mshort/fshort-double/mlong-calls/libbcc.a

ln $LIBDIR/fshort-double/libm.a $LIBDIR/fshort-double/mlong-calls/libm.a
ln $LIBDIR/fshort-double/libc.a $LIBDIR/fshort-double/mlong-calls/libc.a
ln $LIBDIR/fshort-double/sim-valid.ld $LIBDIR/fshort-double/mlong-calls/sim-valid.ld
ln $LIBDIR/fshort-double/crt0.o $LIBDIR/fshort-double/mlong-calls/crt0.o
ln $LIBDIR/fshort-double/libbcc.a $LIBDIR/fshort-double/mlong-calls/libbcc.a

%preun
# Workarround for rpm Bug 75057 (fixed in rpm 4.2)
if test "T$RPM_INSTALL_PREFIX" = "T"; then
  RPM_INSTALL_PREFIX="/usr"
fi
# The 68HC11 libraries compiled with -mlong-calls are identical to compiling
# without that option.  Use links.
LIBDIR="$RPM_INSTALL_PREFIX/m6811-elf/lib"
rm -f $LIBDIR/mlong-calls/libm.a
rm -f $LIBDIR/mlong-calls/libc.a
rm -f $LIBDIR/mlong-calls/sim-valid.ld
rm -f $LIBDIR/mlong-calls/crt0.o
rm -f $LIBDIR/mlong-calls/libbcc.a

rm -f $LIBDIR/mshort/mlong-calls/libm.a
rm -f $LIBDIR/mshort/mlong-calls/libc.a
rm -f $LIBDIR/mshort/mlong-calls/sim-valid.ld
rm -f $LIBDIR/mshort/mlong-calls/crt0.o
rm -f $LIBDIR/mshort/mlong-calls/libbcc.a

rm -f $LIBDIR/mshort/fshort-double/mlong-calls/libm.a
rm -f $LIBDIR/mshort/fshort-double/mlong-calls/libc.a
rm -f $LIBDIR/mshort/fshort-double/mlong-calls/sim-valid.ld
rm -f $LIBDIR/mshort/fshort-double/mlong-calls/crt0.o
rm -f $LIBDIR/mshort/fshort-double/mlong-calls/libbcc.a

rm -f $LIBDIR/fshort-double/mlong-calls/libm.a
rm -f $LIBDIR/fshort-double/mlong-calls/libc.a
rm -f $LIBDIR/fshort-double/mlong-calls/sim-valid.ld
rm -f $LIBDIR/fshort-double/mlong-calls/crt0.o
rm -f $LIBDIR/fshort-double/mlong-calls/libbcc.a

%clean
echo "Cleaning up"
#rm -rf /usr/src/RPM/BUILD/releases/3.1/newlib-inst
