#
# Run with: rpm -bb newlib-win-rpm.pkg
#
Summary: Newlib for 68HC11 and 68HC12 microcontrollers (Win32)
Name: newlib-68hc1x-win32
Version: 1.12.0
Release: 3.1
Copyright: GPL
Group: Development/68HC1x
Source: newlib-1.12.0.tar.bz2
Patch: newlib-1.12.0-m68hc1x-20040801.diffs
URL: http://www.gnu-m68hc11.org
Distribution: Windows 95
Vendor: FSF
Packager: stcarrez@nerim.fr
Buildroot: /usr/src/RPM/BUILD/releases/3.1/newlib-inst-win32
Prefix: /usr
%description
This package contains a set of development libraries for 
Motorola 68HC11 and 68HC12 microcontrollers. 
The following libraries are provided:
  libc     - Standard C library
  libm     - Math library
  libbcc   - Board support library

These libraries are provided in several binary versions.
They are selected by gcc according to the compilation options:

 Kind         Mode     Gcc option         Mode     Gcc option
+-----------+---------------------------+----------------------------+
|Processor  | 68hc11   -m68hc11         | 68hc12   -m68hc12          |
|Integer    | 16-bits  -mshort          | 32-bits  -mnoshort         |
|Float      | 32-bits  -fshort-double   | 64-bits  -fno-short-double |
|Far calls  |                           | call/rtc -mlong-calls      |
+-----------+---------------------------+----------------------------+

Up to 16 combinations are possible (but the -mlong-calls is 
ignored for 68HC11).
%prep

%setup -T -c

%build

%install
export PATH=/tools/mingw32/cross-tools-3.3/bin:/bin:/usr/bin:$PATH

NEWLIB_RPM=/usr/src/RPM/RPMS/i586/newlib-68hc1x-1.12.0-3.1.i586.rpm
if test ! -d $RPM_BUILD_ROOT; then
  mkdir $RPM_BUILD_ROOT
fi
cd $RPM_BUILD_ROOT
if test -d usr; then
  find usr -type f | xargs chmod u+w
  find usr -type d | xargs chmod u+w
  rm -rf usr/m6811-elf
fi
rpm2cpio $NEWLIB_RPM | cpio --no-absolute-filenames --make-directories \
				-m --extract

#
# Dosify the text files (includes)
#
cd $RPM_BUILD_ROOT/usr
echo "Dosifying..."
apply-cmd-on-tree "*.h" unix2dos.pl

%files
#%doc README
%attr(555,root,root) %dir /usr
%attr(555,root,root) %dir /usr/m6811-elf
%attr(555,root,root) %dir /usr/m6811-elf/lib
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/mshort
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/mshort/fshort-double
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/fshort-double
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/m68hc12/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/mshort
%attr(555,root,root) %dir /usr/m6811-elf/lib/mshort/fshort-double
%attr(555,root,root) %dir /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/mshort/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/fshort-double
%attr(555,root,root) %dir /usr/m6811-elf/lib/fshort-double/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/lib/mlong-calls
%attr(555,root,root) %dir /usr/m6811-elf/include
%attr(555,root,root) %dir /usr/m6811-elf/include/machine
%attr(555,root,root) %dir /usr/m6811-elf/include/sys
%attr(444,root,root) /usr/m6811-elf/lib/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/fshort-double/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mshort/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/fshort-double/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mlong-calls/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mlong-calls/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mlong-calls/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mlong-calls/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/m68hc12/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/libc.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls/libm.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls/sim-valid.ld
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls/crt0.o
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/mshort/fshort-double/libbcc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/mlong-calls/libm.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/mlong-calls/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/mlong-calls/sim-valid.ld
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/mlong-calls/crt0.o
#%attr(444,root,root) /usr/m6811-elf/lib/mshort/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/mshort/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/mshort/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/mshort/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/libm.a
%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/mlong-calls/libm.a
#%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/mlong-calls/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/mlong-calls/sim-valid.ld
#%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/mlong-calls/crt0.o
#%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/fshort-double/libbcc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mlong-calls/libm.a
#%attr(444,root,root) /usr/m6811-elf/lib/mlong-calls/libc.a
#%attr(444,root,root) /usr/m6811-elf/lib/mlong-calls/sim-valid.ld
#%attr(444,root,root) /usr/m6811-elf/lib/mlong-calls/crt0.o
#%attr(444,root,root) /usr/m6811-elf/lib/mlong-calls/libbcc.a
%attr(444,root,root) /usr/m6811-elf/lib/sim-valid.ld
%attr(444,root,root) /usr/m6811-elf/lib/crt0.o
%attr(444,root,root) /usr/m6811-elf/lib/libbcc.a
%attr(444,root,root) /usr/m6811-elf/include/machine/*.h
%attr(444,root,root) /usr/m6811-elf/include/*.h
%attr(444,root,root) /usr/m6811-elf/include/sys/*.h

#
# Package installation.
#
%post

%preun

%clean
echo "Cleaning up"
#rm -rf /usr/src/RPM/BUILD/releases/3.1/newlib-inst-win32
